/*
* Copyright (c) OpenSim project, http://sim.opensecondlife.org/
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of the <organization> nor the
*       names of its contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY <copyright holder> ``AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL <copyright holder> BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
* 
*/

using System;
using libsecondlife;
using OpenSim.Framework.Types;

namespace OpenSim.Framework.Interfaces
{
    /// <summary>
    /// ILocalStorage. Really hacked together right now needs cleaning up
    /// </summary>
    public interface ILocalStorage
    {
        void Initialise(string datastore);
        
        void StorePrim(PrimData prim);
        void RemovePrim(LLUUID primID);
        void LoadPrimitives(ILocalStorageReceiver receiver);
        
        float[] LoadWorld();
        void SaveMap(float[] heightmap);

        void SaveParcels(ParcelData[] parcels);
        void SaveParcel(ParcelData parcel);
        void RemoveParcel(ParcelData parcel);
        void RemoveAllParcels();
        void LoadParcels(ILocalStorageParcelReceiver recv);

        void ShutDown();
    }

    public interface ILocalStorageReceiver
    {
        void PrimFromStorage(PrimData prim);
    }
    
    public interface ILocalStorageParcelReceiver
    {
        void ParcelFromStorage(ParcelData data);
        void NoParcelDataFromStorage();
    }
}

